#include <stdio.h>
#include <errno.h>
#include "dio.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>   

#define DEV "/dev/dio"

#define N 10000

main(){
int	fio;
unsigned int data[N];
char 	channels[20];
unsigned int in,out;
int	err;
	printf("Testing reading and writing\n");
	printf("Under this test port 1 should be connected via ribbons to port 0\n");
	printf("About to open %s\n",DEV);
	fio=open(DEV,O_RDWR);
	if(fio==-1){
		printf("Failed to open %s\n",DEV);
		perror("TestDev error:");
		exit(1);
		}
	printf("Set all the bits in port 1 to read and all in port 0 to write\n");
	/* NOTE THAT 0=READ 1=WRITE so flag writes only - matt 2001*/
	ioctl(fio,DIO_DIR,DIO_PORT0);

	/* set the data port read port to port 1 only */
	ioctl(fio,DIO_READ_SEQ,DIO_PORT1);
	/* set the data port write port to port 1 only */
	ioctl(fio,DIO_WRITE_SEQ,DIO_PORT0);
	printf("Setting the delay to 0\n");
	ioctl(fio,DIO_SET_DELAY,0);
	printf("Reading from port 1\n");
	read(fio,(void *)&in,sizeof(unsigned int));
	printf("Read %x\n",in);
	do{
		printf("\nEnter a u32 in hex to write (0 to quit)");
		scanf("%x",&out);
		if(out==0)break;
		printf("Writing %x to port 0\n",out);
		write(fio,(void *)&out,sizeof(unsigned int));
		printf("Done\n");
	
		printf("Reading from port 1\n");
		read(fio,(void *)&in,sizeof(unsigned int));
		printf("Read %x\n",in);
		}while(out!=0);	

	close(fio);
}
