#include <stdio.h>
#include <errno.h>
#include "dio.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>   

#define DEV "/dev/dio"

#define N 1000

main(){
int	fio;
unsigned int data[N];
char 	channels[20];
int	err;
	printf("Testing write\n");
	printf("About to open %s\n",DEV);
	fio=open(DEV,O_RDWR);
	if(fio==-1){
		printf("Failed to open %s\n",DEV);
		perror("TestDev error:");
		exit(1);
		}
	ioctl(fio,DIO_DIR,DIO_ALL_WRITE);
	ioctl(fio,DIO_WRITE_SEQ,DIO_PORT0);
	printf("Reading %d unsigned ints\n",N);
	err=write(fio,(void *)data,N*sizeof(unsigned int));
	if(err<0){
		perror("dio_testwrite:");
		}
	else{
		printf("It returned %d bytes\n",err);
		}
	printf("About to set a delay (but a fast one)\n");
	ioctl(fio,DIO_SET_DELAY,1000);
	printf("Reading %d unsigned ints\n",N);
	err=write(fio,(void *)data,N*sizeof(unsigned int));
	if(err<0){
		perror("dio_testwrite:");
		}
	else{
		printf("It returned %d bytes\n",err);
		}
	printf("About to set a delay (but a slow one)\n");
	ioctl(fio,DIO_SET_DELAY,20000);
	printf("Reading %d unsigned ints\n",N);
	err=write(fio,(void *)data,N*sizeof(unsigned int));
	if(err<0){
		perror("dio_testwrite:");
		}
	else{
		printf("It returned %d bytes\n",err);
		}

	

	close(fio);
}
